'********************************************************************
'*  Name    : Sparkfun_V2.5_Serial_LCD.BAS                          *
'*  Receive Data with serial lcd's RX pin connected to PORTC.6 (RC6)*
'*  Date    : 22/03/2009                                            *
'********************************************************************
'*  BACKLIGHT CONTROL                                               *
'*  =================                                               *
'*  Any number between 128(off)To 157 (full On)                     *
'*  124,157	'Sets backlight full on                                 *
'*	124,150 'Sets backlight 73%  on 				                *                   
'*  124,140 'Sets backlight 40%  on                                 *          
'*  124,128 'Sets backlight off                                     *         
'*========================================                          *
'*  Special Commad's                                                *
'*  ================                                                *
'*  124,9   'Toggles Splash Screen On- Off                          *
'*  254,1   'Clears Screen                                          *   
'*  254,08  'Turn's Display Off                                     *
'*  254,12  'Turn's Display On                                      *
'*  There are more commands just never tried them                   *
'*  Schematic and hex file available free for personal use at       *
'*  www.sparkfun.com for anyone who want's to make their own        *
'********************************************************************  
  
'===========================================================================
 Device 16F877A              
 Xtal = 8
'===========================================================================
  Hserial_Baud = 9600        ' Set baud rate to 9600
  Hserial_RCSTA = %10010000  ' Enable serial port and continuous receive
  Hserial_TXSTA = %00100000  ' Enable transmit and asynchronous mode 
  Hserial_Clear = On         ' Optionally clear the buffer before receiving
'===========================================================================
' Setup PortC as all output
'===========================================================================
 TRISC = %0000000            ' Set Tris Register to Output
 PORTC = %0000000            ' Set PortC to Output
'===========================================================================
' Send data to the Lcd
'===========================================================================
main:
  
      DelayMS 100                            ' Small delay to settle the display (mine needed it)
  HRSOut 254,$01                             ' clears the display
      DelayMS 50                             ' delay between commands
  HRSOut 254,128,"Display Line one"          ' Sends text to line 1 position 1
      DelayMS 2500                           ' and display's it for 2.5 sec 
  HRSOut 254,192,"Display Line two"          ' Sends text to line 2 position 1
      DelayMS 2500                           ' and display's it for 2.5 sec
  HRSOut 254,1                               ' Clears Display
      DelayMS 50                             ' delay between commands
  HRSOut 254,128, "Turn off Display"         ' Sends text to line 1 position 1
      DelayMS 2500                           ' and display for 2.5 sec
  HRSOut 254,08                              ' Turn's Display Off 
     DelayMS 2500                            ' for 2.5 sec 
  HRSOut 254,12                              ' Turn's Display back On 
     DelayMS 50                              ' delay between command's
  HRSOut 254,1                               ' Clears Display for new Data
      DelayMS 50                             ' delay between command's
  HRSOut 254,128, "Turn on Display"          ' Sends text to line 1 position 1
     DelayMS 2500                            ' and displays it for 2.5 sec 
  HRSOut 254,1                               ' Clears Display
  HRSOut 254,128,"Turn backlight  on to 40%" ' Sends text To Line 1 position 1
'*************** " 25 characters above here " this text will wrap To Line 2 automatically
  HRSOut 124,140                             ' Turn Backlight down to 40%
      DelayMS 3500                           ' delay for 3.5 sec so you can see the change
  HRSOut 254,128,"Turn backlight  up to 100%"' Sends text To Line 1 position 1
'*************** " 26 characters above here " this text will wrap To Line 2 automatically              
  HRSOut 124,157                             ' Turn Backlight on 100%
      DelayMS 3500                           ' delay for 3.5 sec so you can see the change
  HRSOut 254,$01                             ' clears the display
      DelayMS 50                             ' delay between commands
  HRSOut 254,128,"Go to the start"           ' Sends text to line 1 position 1
      DelayMS 50                             ' and display's it for 0.5 sec 
  HRSOut 254,192,"And do it again"           ' Sends text to line 2 position 1
      DelayMS 2500                           ' and display's it for 1.5 sec
  HRSOut 254,1                               ' Clears Display
      DelayMS 50                             ' delay between commands
GoTo main                                    ' Goto Main: and do start it over
